/*
 * Created on Mar 27, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.eclipse.ui.extensionevents;

import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.core.runtime.IExtension;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.internal.WorkbenchPlugin;

public class ExtensionEventDispatcher {

	//for dynamic loading
	private static ArrayList extensionListeners = new ArrayList();

	//for dynamic loading
	public static void addExtensionListener(IExtensionListener listener) {
		extensionListeners.add(listener);
	}
	
	//for dynamic loading
	public static void removeExtensionListener(IExtensionListener listener) {
		extensionListeners.remove(listener);
	}

	//for dynamic loading
	public static void fireExtensionRevokeEvent(IExtensionPoint extpt, IExtension ext) {

		WorkbenchPlugin plugin = WorkbenchPlugin.getDefault();
		if (plugin==null) return;
//		Display display = plugin.getDisplay();
		Display display = plugin.getWorkbench().getActiveWorkbenchWindow().getShell().getDisplay();
		if (display==null) return;
		Iterator iterator = extensionListeners.iterator();
		while(iterator.hasNext()) {
			IExtensionListener listener = (IExtensionListener) iterator.next();
			asyncRevoke(display,listener,extpt,ext);
		}
	}
	private static void asyncRevoke(Display display, final IExtensionListener listener, final IExtensionPoint extpt, final IExtension ext) {
		if (display==null)
			listener.revoke(extpt, ext);
		else {
			Runnable run = new Runnable() {
				public void run() {
					listener.revoke(extpt, ext);
				}						
			};
			display.syncExec(run);
		}
	}

	//for dynamic loading
	public static void fireExtensionAppearEvent(IExtensionPoint extpt, IExtension ext) {
		WorkbenchPlugin plugin = WorkbenchPlugin.getDefault();
		if (plugin==null) return;
//		Display display = plugin.getDisplay();
		Display display = plugin.getWorkbench().getActiveWorkbenchWindow().getShell().getDisplay();
		if (display==null) return;
		Iterator iterator = extensionListeners.iterator();
		while(iterator.hasNext()) {
			IExtensionListener listener = (IExtensionListener) iterator.next();
			asyncAppear(display,listener,extpt,ext);
		}
	}
	private static void asyncAppear(Display display, final IExtensionListener listener, final IExtensionPoint extpt, final IExtension ext) {
		if (display==null)
			listener.appear(extpt, ext);
		else {
			Runnable run = new Runnable() {
				public void run() {
					listener.appear(extpt, ext);
				}						
			};
			display.syncExec(run);
		}
	}

	//for dynamic loading
	public static void fireExtensionStopEvent(IExtensionPoint extpt, IExtension ext) {
		WorkbenchPlugin plugin = WorkbenchPlugin.getDefault();
		if (plugin==null) return;
//		Display display = plugin.getDisplay();
		Display display = plugin.getWorkbench().getActiveWorkbenchWindow().getShell().getDisplay();
		if (display==null) return;
		Iterator iterator = extensionListeners.iterator();
		while(iterator.hasNext()) {
			IExtensionListener listener = (IExtensionListener) iterator.next();
			asyncStop(display,listener,extpt,ext);
		}
	}
	private static void asyncStop(Display display, final IExtensionListener listener, final IExtensionPoint extpt, final IExtension ext) {
		if (display==null)
			listener.stop(extpt, ext);
		else {
			Runnable run = new Runnable() {
				public void run() {
					listener.stop(extpt, ext);
				}						
			};
			display.syncExec(run);
		}
	}

}
